Subject: Re: ssb: Fix DMA-API compilation for non-PCI systems

From: Michael Buesch <[email-masked]>
Date: Tue, 11 Nov 2008 00:32:00 +0100

On Monday 10 November 2008 23:53:43 David Miller wrote:
> Then those architectures need to fix their implementations,
> simply.  They aren't implementing the generic DMA interfaces
> properly.  Other subsystems do make use of the generic DMA
> interfaces in this way.
> 
> Even something as simple as checking for &pci_bus_type in the
> dma_*() routines (like powerpc did for quite some time) is
> enough to fix the problem.

Yeah, sure. The architectures are broken.
But the bugreports hit _my_ code. I got pretty tired of forwarding stuff
to the arch maintainers, so I implemented something that does work in
every situation. The bugreports stopped immediately (Except this tiny build
failure that does only hit under rare circumstances).

DMA is pretty much a mess, if you look at how ever arch does implement the API
in a slightly different way.
If somebody wants to fix this, I'm certainly OK with it. But for now we will
have to live with SSB implementing a wrapper around the ssb-host-device DMA APIs.

-- 
Greetings Michael.